
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Compare.Models;

public record CompareSettings(string Company,
                              string FacesFileNameExtension,
                              string FacesHiddenFileNameExtension,
                              string FacesPartsFileNameExtension,
                              string[] IgnoreExtensions,
                              int MaxDegreeOfParallelism,
                              string[] OutputResolutions,
                              string[] ValidImageFormatExtensions,
                              string[] ValidVideoFormatExtensions) : Shared.Models.Properties.ICompareSettings
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, CompareSettingsSourceGenerationContext.Default.CompareSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(CompareSettings))]
internal partial class CompareSettingsSourceGenerationContext : JsonSerializerContext
{
}