
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Rename.Models;

public record RenameSettings(string Company,
                             string DefaultMaker,
                             bool ForceNewId,
                             string[] IgnoreExtensions,
                             bool InPlace,
                             bool InPlaceMoveDirectory,
                             bool InPlaceWithOriginalName,
                             int MaxDegreeOfParallelism,
                             bool OnlySaveIdentifiersToDisk,
                             string RelativePropertyCollectionFile,
                             bool RequireRootDirectoryExists,
                             string[] SidecarExtensions,
                             bool SkipIdFiles,
                             string[] ValidImageFormatExtensions,
                             string[] ValidVideoFormatExtensions) : Shared.Models.Properties.IRenameSettings
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, RenameSettingsSourceGenerationContext.Default.RenameSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(RenameSettings))]
internal partial class RenameSettingsSourceGenerationContext : JsonSerializerContext
{
}